#*************************************************************
# Progamm:			gitter_2d
# Sinn des Programms: 		Gittergenerator 2d
# Sinn der Einheit  :		Ausgabe des Gitters
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		gitter_2d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			13.09.2020
# Letzte Änderung: 		10.02.2023
#*************************************************************



#*************************************************************
# Importieren der Klassen
# matplotlib.pyplot: für graphische Ausgabe
#*************************************************************

import os
import pickle
import matplotlib.pyplot as plt
#import numpy as np

#*************************************************************
# Klassendefinition: Ausgabe
#*************************************************************



class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt") 

  def ausgabe_rückgabeliste_init(self):
    self.rückgabeliste = list(range(10))
    print("init: rückgabeliste")
        
  def schirm_ausgabe_fdm(self, m, n, x, y, delta_x, delta_y):
    try:  
      print("FDM-Schirmausgabe")
      for i in range(m):
        for j in range(n):
          print(i, j, x[i][j], y[i][j])
      for i in range(m-1):
        for j in range(n):
          print("delta_x: ", delta_x[i][j])  
      for i in range(m):
        for j in range(n-1):
          print("delta_y: ", delta_y[i][j])       
      self.rückgabeliste[0] = True        
      self.rückgabeliste[1] = "FDM-Gitter auf Schirm ausgegeben." 
    except:
      self.rückgabeliste[0] = False    
      self.rückgabeliste[1] = "Fehler bei FDM-Gitter Schirmausgegabe."                
    return self.rückgabeliste[0]
    
    
  def schirm_ausgabe_fvm(self, m, n, x, y, delta_x, delta_y, x_gf, y_gf, A_gf_we, A_gf_sn, Delta_x, Delta_y, V):
    try:
      print("FVM-Schirmausgabe")
      for i in range(m):
        for j in range(n):
          print(i,j, x[i][j], y[i][j] )
        
      for i in range(m-1):
        for j in range(n):
          print(i,j, delta_x[i][j] )
      for i in range(m):
        for j in range(n-1):
          print(i,j,  delta_y[i][j] )
        
      for i in range(m-1):
        for j in range(n-1):
          print(i,j,x_gf[i][j], y_gf[i][j])
        
      for i in range(m-1): #hier: Indizes?
        for j in range(n-2):  #hier: Indizes?  
          print("gigi",i,j,  A_gf_we[i][j])
                
      for i in range(m-2):  #hier: Indizes?
        for j in range(n-1): #hier: Indizes?
          print(i,j,  A_gf_sn[i][j] )
        
      for i in range(m-2):
        for j in range(n-1):    
          print(i,j,  Delta_x[i][j])
        
      for i in range(m-1):
        for j in range(n-2):    
          print(i,j,  Delta_y[i][j])
         
      for i in range(m-2): #hier: Indizes?
        for j in range(n-2):   #hier: Indizes? 
          print(i,j, V[i][j])
      self.rückgabeliste[0] = True        
      self.rückgabeliste[1] = "FVM-Gitter auf Schirm ausgegeben." 
    except:
      self.rückgabeliste[0] = False    
      self.rückgabeliste[1] = "Fehler bei FVM-Gitter Schirmausgegabe."                
    return self.rückgabeliste[0]
    
  def datei_ausgabe_fdm(self, gitter_datei, index_ausgabe_wähler, ascii_bin, m, n, x, y, delta_x, delta_y):
    try:  
      if ascii_bin == "a":
        fobj_out = open(gitter_datei,"w")
        fobj_out.write(str(index_ausgabe_wähler))
        fobj_out.write("\n")
        fobj_out.write("d")
        fobj_out.write("\n")
        fobj_out.write(str(m))
        fobj_out.write("\t")
        fobj_out.write(str(n))
        fobj_out.write("\n")
        if index_ausgabe_wähler:
          self.rückgabeliste[5] = "Indexausgabe in Datei"         
          for i in range(m):
            for j in range(n):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(x[i][j]))
              fobj_out.write("\t")
              fobj_out.write(str(y[i][j]))
              fobj_out.write("\n")
          for i in range(m-1):
            for j in range(n):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(delta_x[i][j]))
              fobj_out.write("\n")
          for i in range(m):
            for j in range(n-1):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(delta_y[i][j]))
              fobj_out.write("\n")  
        else:
          self.rückgabeliste[5] = "keine Indexausgabe in Datei"         
          for i in range(m):
            for j in range(n):
              fobj_out.write(str(x[i][j]))
              fobj_out.write("\t")
              fobj_out.write(str(y[i][j]))
              fobj_out.write("\n")
          for i in range(m-1):
            for j in range(n):
              fobj_out.write(str(delta_x[i][j]))
              fobj_out.write("\n") 
          for i in range(m):
            for j in range(n-1):  
              fobj_out.write(str(delta_y[i][j]))
              fobj_out.write("\n")
        self.rückgabeliste[4] = "Dateiausgabe in ASCII-Code"                     
        fobj_out.close()
      elif ascii_bin == "b":
        fobj_out = open(gitter_datei,"wb")
        print("Binär o.k.")
        pickle.dump("d",fobj_out)
        pickle.dump(m,fobj_out)
        pickle.dump(n,fobj_out)
        pickle.dump(x,fobj_out)
        pickle.dump(y,fobj_out)
        pickle.dump(delta_x,fobj_out)  
        pickle.dump(delta_y,fobj_out)  
        self.rückgabeliste[4] = "Dateiausgabe binär" 
        self.rückgabeliste[5] = "keine Indexausgabe in Datei"           
        fobj_out.close()
      else:
        print("Fehler!") 
        self.rückgabeliste[4] = "Fehler in Zuordnung ASCII- oder Binärcodeausgabe"
      self.rückgabeliste[2] = True        
      self.rückgabeliste[3] = "FDM-Gitter in Datei ausgegeben."   
    except:     
      self.rückgabeliste[2] = False    
      self.rückgabeliste[3] = "Fehler bei FDM-Gitter Dateiausgegabe."                
    return self.rückgabeliste[2]
                                          
  def datei_ausgabe_fvm(self,gitter_datei, index_ausgabe_wähler, ascii_bin, m,n,x,y, delta_x, delta_y, x_gf, y_gf, A_gf_we, A_gf_sn, Delta_x, Delta_y, V):
    try:
      print("ascii_bin = ",ascii_bin)
      if ascii_bin == "a":
        fobj_out = open(gitter_datei,"w")
        fobj_out.write(str(index_ausgabe_wähler))
        fobj_out.write("\n")
        fobj_out.write("v")
        fobj_out.write("\n")
        fobj_out.write(str(m))
        fobj_out.write("\t")
        fobj_out.write(str(n))
        fobj_out.write("\n")
        if index_ausgabe_wähler:
          self.rückgabeliste[5] = "Indexausgabe in Datei"         
          for i in range(m):
            for j in range(n):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(x[i][j]))
              fobj_out.write("\t")
              fobj_out.write(str(y[i][j]))
              fobj_out.write("\n")
          for i in range(m-1):
            for j in range(n):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(delta_x[i][j]))
              fobj_out.write("\n")
          for i in range(m):
            for j in range(n-1):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")            
              fobj_out.write(str(delta_y[i][j]))
              fobj_out.write("\n")      
          for i in range(m-1):
            for j in range(n-1):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(x_gf[i][j]))
              fobj_out.write("\t")
              fobj_out.write(str(y_gf[i][j]))
              fobj_out.write("\n") 
          for i in range(m-1):
            for j in range(n-2):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(A_gf_we[i][j]))
              fobj_out.write("\n")                    
          for i in range(m-2):
            for j in range(n-1):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(A_gf_sn[i][j]))
              fobj_out.write("\n") 
          for i in range(m-2):
            for j in range(n-1):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(Delta_x[i][j]))
              fobj_out.write("\n")
          for i in range(m-1):
            for j in range(n-2):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(Delta_y[i][j]))
              fobj_out.write("\n")    
          for i in range(m-2):
            for j in range(n-2):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(j))
              fobj_out.write("\t")
              fobj_out.write(str(V[i][j]))
              fobj_out.write("\n")
        else:
          self.rückgabeliste[5] = "keine Indexausgabe in Datei"         
          for i in range(m):
            for j in range(n):
              fobj_out.write(str(x[i][j]))
              fobj_out.write("\t")
              fobj_out.write(str(y[i][j]))
              fobj_out.write("\n")
          for i in range(m-1):
            for j in range(n):
              fobj_out.write(str(delta_x[i][j]))
              fobj_out.write("\n") 
          for i in range(m):
            for j in range(n-1):  
              fobj_out.write(str(delta_y[i][j]))
              fobj_out.write("\n")               
          for i in range(m-1):
            for j in range(n-1):
              fobj_out.write(str(x_gf[i][j]))
              fobj_out.write("\t")
              fobj_out.write(str(y_gf[i][j]))
              fobj_out.write("\n")
          for i in range(m-1):
            for j in range(n-2):
              fobj_out.write(str(A_gf_we[i][j]))
              fobj_out.write("\n")            
          for i in range(m-2):
            for j in range(n-1):
              fobj_out.write(str(A_gf_sn[i][j]))
              fobj_out.write("\n")    
          for i in range(m-2):
            for j in range(n-1):
              fobj_out.write(str(Delta_x[i][j]))
              fobj_out.write("\n")
          for i in range(m-1):
            for j in range(n-2):
              fobj_out.write(str(Delta_y[i][j]))
              fobj_out.write("\n")
          for i in range(m-2):
            for j in range(n-2):
              fobj_out.write(str(V[i][j]))
              fobj_out.write("\n")  
        self.rückgabeliste[4] = "Dateiausgabe in ASCII-Code"                 
        fobj_out.close() 
      elif ascii_bin == "b":
        fobj_out = open(gitter_datei,"wb")
        pickle.dump("v",fobj_out)
        pickle.dump(m,fobj_out)
        pickle.dump(n,fobj_out)

        pickle.dump(x,fobj_out)
        pickle.dump(y,fobj_out)
        pickle.dump(delta_x,fobj_out)  
        pickle.dump(delta_y,fobj_out)  

        pickle.dump(x_gf,fobj_out)
        pickle.dump(y_gf,fobj_out)
        pickle.dump(A_gf_we,fobj_out)      
        pickle.dump(A_gf_sn,fobj_out)
        pickle.dump(Delta_x,fobj_out)
        pickle.dump(Delta_y,fobj_out)
        pickle.dump(V,fobj_out) 
        self.rückgabeliste[4] = "Dateiausgabe binär" 
        self.rückgabeliste[5] = "keine Indexausgabe in Datei"                  
        fobj_out.close() 
      else:  
        print("Fehler!")
        self.rückgabeliste[4] = "Fehler in Zuordnung ASCII- oder Binärcodeausgabe"
      self.rückgabeliste[2] = True        
      self.rückgabeliste[3] = "FVM-Gitter in Datei ausgegeben."   
    except:     
      self.rückgabeliste[2] = False    
      self.rückgabeliste[3] = "Fehler bei FVM-Gitter Dateiausgegabe."                
    return self.rückgabeliste[2]          
  



  def graphik_ausgabe_fdm(self, m,n,x,y,graphik_datei_ausgabe_wähler ,graphik_datei_name,graphik_datei_format):
    try:  
      x_min=0.0
      x_max=0.0
      y_min=0.0
      y_max=0.0
      for i in range(m):
        for j in range(n):
          if x_min >= x[i][j]:
            x_min = x[i][j]
          if x_max <= x[i][j]:
            x_max = x[i][j]
    
          if y_min >= y[i][j]:
            y_min = y[i][j]
          if y_max <= y[i][j]:
            y_max = y[i][j]    
    
      plt.plot(x, y, 'r.')  
      # Achsen-Bereiche manuell festlegen
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
      x_min-=(x_max-x_min)/10.0
      x_max+=(x_max-x_min)/10.0
      y_min-=(y_max-y_min)/10.0
      y_max+=(y_max-y_min)/10.0
    #plt.axis([x_min, x_max, -0.2, 0.2])
      plt.axis([x_min, x_max, y_min, y_max])
      plt.title("FDM-Gitter" )
      # Ein gepunktetes Diagramm-Gitter einblenden:
      plt.grid(True)
      if(graphik_datei_ausgabe_wähler ):
        try:
          plt.savefig(graphik_datei_name + '.' + graphik_datei_format, format=graphik_datei_format) 
          self.rückgabeliste[8] = True
          self.rückgabeliste[9] = "Graphikdateiausgabe o.k."          
        except:
          print("Graphikdateiformat",graphik_datei_format ,"wird nicht von python unterstützt") 
          print(" unterstützt werden die Formate:",{'eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'} )
          self.rückgabeliste[8] = False
          self.rückgabeliste[9] = "Fehler in der Graphikdateiausgabe!"  
      # Diagramm anzeigen:
      plt.show()    
      self.rückgabeliste[6] = True 
      self.rückgabeliste[7] = "Graphikausgabe o.k."            
    except:    
      self.rückgabeliste[6] = False  
      self.rückgabeliste[7] = "Fehler in der Graphikausgabe." 
    return self.rückgabeliste[6]   


  def graphik_ausgabe_fvm(self,m,n,x,y,x_gf, y_gf, graphik_datei_ausgabe_wähler ,graphik_datei_name,graphik_datei_format): 
    try:  
      x_min=0.0
      x_max=0.0
      y_min=0.0
      y_max=0.0
      for i in range(m):
        for j in range(n):
          if x_min >= x[i][j]:
            x_min = x[i][j]
          if x_max <= x[i][j]:
            x_max = x[i][j]
    
          if y_min >= y[i][j]:
            y_min = y[i][j]
          if y_max <= y[i][j]:
            y_max = y[i][j]    
    
      plt.plot(x, y, 'r.')
      plt.plot(x_gf, y_gf, 'b+')  
      # Achsen-Bereiche manuell festlegen
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
      x_min-=(x_max-x_min)/10.0
      x_max+=(x_max-x_min)/10.0
      y_min-=(y_max-y_min)/10.0
      y_max+=(y_max-y_min)/10.0
    #plt.axis([x_min, x_max, -0.2, 0.2])
      plt.axis([x_min, x_max, y_min, y_max])
      plt.title("FVM-Gitter" )
      # Ein gepunktetes Diagramm-Gitter einblenden:
      plt.grid(True)
      if(graphik_datei_ausgabe_wähler ):
        try:
          plt.savefig(graphik_datei_name + '.' + graphik_datei_format, format=graphik_datei_format) 
          self.rückgabeliste[8] = True
          self.rückgabeliste[9] = "Graphikdateiausgabe o.k."        
        except:
          print("Graphikdateiformat",graphik_datei_format ,"wird nicht von python unterstützt") 
          print(" unterstützt werden die Formate:",{'eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'} )
          self.rückgabeliste[8] = False
          self.rückgabeliste[9] = "Fehler in der Graphikdateiausgabe!"
      # Diagramm anzeigen:
      plt.show()    
      self.rückgabeliste[6] = True
      self.rückgabeliste[7] = "Graphikausgabe o.k."             
    except:   
      self.rückgabeliste[6] = False   
      self.rückgabeliste[7] = "Fehler in der Graphikausgabe."  
    return self.rückgabeliste[6]    
  
