#*************************************************************
# Progamm:			fluisa_gitter_2d
# Sinn des Programms: 		Gittergenerator
# Sinn der Einheit  :		Berechnung des Gitters
# Name dieser Datei:		gitter.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_gitter_2d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			13.09.2020
# Letzte Änderung: 		16.02.2023
#*************************************************************


from steuer import Steuer
import numpy as np

class Gitter:
  #Konstruktormethode
  def __init__(self):		
    print("Gitterobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Gitterobjekt entfernt") 
    
  def gitter_rechner(self,gitter_typ,m,n,x_west, x_ost, y_süd, y_nord,t_init):
    self.rückgabeliste = list(range(3))
    self.rückgabeliste[0] = True 				# Einlesen des Gitters korrekt            	True/False
    self.rückgabeliste[1] = "Gitter wurde korrekt errechnet."	# Fehlermeldung für Einlesen aus Gitterdatei  	Text
    self.rückgabeliste[2] = "FVM-Gitter"			# Gittertyp 					Text
 
    try:
      print("Gittergenerator")    
      print("Art des Gitters:",gitter_typ)
      print("Anzahl der Gitterpunkte in Gitter",m,n)
      print("Gittergrenzen: ",x_west, x_ost)
      print("Grenzflächeninhalt",t_init)
      print("Art des Gitters:",gitter_typ)
                    
      self.x = np.zeros((m,n))
      self.y = np.zeros((m,n)) 
      self.delta_x = np.zeros((m-1,n))
      self.delta_y = np.zeros((m,n-1))
            
      if gitter_typ == 'v' :
        m -= 1
        n -= 1 

      if self.fdm_gitter(gitter_typ, m,n, x_west, x_ost,y_süd, y_nord):
        pass
      else:
        self.rückgabeliste[0] = False
        
      if gitter_typ == "d" :
        self.rückgabeliste[2] = "FDM-Gitter"           
      elif gitter_typ == "v" :
        if self.fvm_gitter(gitter_typ, m,n, x_west, x_ost, y_süd, y_nord,t_init):
          self.rückgabeliste[2] = "FVM-Gitter"
        else:
          self.rückgabeliste[0] = False
      else:
        print("Fehler im System")    
        self.rückgabeliste[0] = False
       
    except:
      self.rückgabeliste[0] = False
    print("Fehlermelder:",self.rückgabeliste[0])
    return self.rückgabeliste[0]
        

  def fdm_gitter(self,gitter_typ, m,n, x_west, x_ost, y_süd, y_nord):
    try:
      print("Primärgitter wurde berechnet")
      print("Grenzen:", x_west, x_ost, y_süd, y_nord)
      self.delta_x_init = (x_ost-x_west)/float(m-1)
      self.delta_y_init = (y_nord-y_süd)/float(n-1)
      print(self.delta_x_init, self.delta_y_init)
      for i in range(m):
        for j in range(n):
          self.x[i][j] = x_west + float(i)*self.delta_x_init
          self.y[i][j] = y_süd + float(j)*self.delta_y_init
          #print("primäres Gitter i=",i,"j=",j,"x=", self.x_prim[i][j],"y=",self.y_prim[i][j]) 
      for i in range(m-1):
        for j in range(n):
          self.delta_x[i][j] = self.x[i+1][j] - self.x[i][j]

      for i in range(m):
        for j in range(n-1):
          self.delta_y[i][j] = self.y[i][j+1] - self.y[i][j]      
          
      return True
    except:
      print("Fehler bei der Berechnung des Primärgitters")
      return False  
      
  def fvm_gitter(self,gitter_typ, m,n, x_west, x_ost,y_süd, y_nord, t_init):
    print("FVM-Gitter")      
    try:
      print("FVM-Gitter")
#    m, n um 1 reduziert      
      self.x_gf = np.zeros((m,n))
      self.y_gf = np.zeros((m,n)) 
      self.Delta_x = np.zeros((m-1,n))
      self.Delta_y = np.zeros((m,n-1)) 
 
    # Grenzflächen 
    # Anfangs- und Endpunkte
      for i in range(m):
        for j in range(n):              
          self.x_gf[i][j] = self.x[i][j]
          self.y_gf[i][j] = self.y[i][j]
          print("Position der Wände",i,j,self.x_gf[i][j],self.y_gf[i][j])

      for i in range(m-1):
        for j in range(n):      
          self.Delta_x[i][j] = self.delta_x[i][j]
              
      for i in range(m):
        for j in range(n-1):
          self.Delta_y[i][j] = self.delta_y[i][j]
      
      
      self.V = np.zeros((m-1,n-1))  
      
 
      self.t_gf_we = np.zeros((m,n-1)) # t_gf_we: Tiefe der westlichen bzw. östlichen Grenzfläche - erstreckt in süd-nord-Richtung 
      self.t_gf_sn = np.zeros((m-1,n)) # t_gf_sn: Tiefe der südlichen bzw. nördlichen Grenzfläche - erstreckt in west-ost-Richtung      
      self.A_gf_we = np.zeros((m,n-1)) # A_gf_we: Flächeninhalt der westlichen bzw. östlichen Grenzfläche - erstreckt in süd-nord-Richtung        
      self.A_gf_sn = np.zeros((m-1,n)) # A_gf_sn: Flächeninhalt der südlichen bzw. nördlichen Grenzfläche - erstreckt in west-ost-Richtung 
            
      for i in range(m):
        for j in range(n-1):
          self.t_gf_we[i][j] = t_init

      for i in range(m-1):
        for j in range(n):   
          self.t_gf_sn[i][j] = t_init          

            
      for i in range(m):
        for j in range(n-1):
          self.A_gf_we[i][j] =  self.Delta_y[i][j] * self.t_gf_we[i][j] # A_gf_we: Flächeninhalt der westlichen bzw. östlichen Grenzfläche - erstreckt in süd-nord-Richtung  

      for i in range(m-1):
        for j in range(n):  
          self.A_gf_sn[i][j] = self.Delta_x[i][j] * self.t_gf_sn[i][j] # A_gf_sn: Flächeninhalt der südlichen bzw. nördlichen Grenzfläche - erstreckt in west-ost-Richtung 

      for i in range(m-1):
        for j in range(n-1):
          self.V[i][j] = self.A_gf_sn[i][j] * self.Delta_y[i][j]
          print("Volumen:",i,j, self.V[i][j])



# Neuberechnung von x und delta_x
# Eckpunkte
# Süd-West-Ecke
      self.x[0][0] = self.x[0][0]
      self.y[0][0] = self.y[0][0]      

# Nord-West-Ecke
      self.x[0][n] = self.x_gf[0][n-1]
      self.y[0][n] = self.y_gf[0][n-1]

# Süd-Ost-Ecke      
      self.x[m][0] = self.x[m-1][0]
      self.y[m][0] = self.y[m-1][0]      

# Nord-Ost-Ecke      
      self.x[m][n] = self.x[m-1][n-1]
      self.y[m][n] = self.y[m-1][n-1]          
      
# Westrand
      for j in range(1,n):
        self.x[0][j] = x_west
        self.y[0][j] = y_süd + (float(j)-0.5)*self.delta_y_init
#        print("Westrand 0",j,  self.x[0][j], self.y[0][j])

# Ostrand
      for j in range(1,n):
        self.x[m][j] = x_ost
        self.y[m][j] = y_süd + (float(j)-0.5)*self.delta_y_init
#        print("Ostrand", m,j,  self.x[m][j], self.y[m][j])

# Südrand
      for i in range(1,m):
        self.x[i][0] = x_west + (float(i)-0.5)*self.delta_x_init
        self.y[i][0] = y_süd 
#        print("Südrand",i,"0",  self.x[i][0], self.y[i][0])

# Nordrand
      for i in range(1,m):
        self.x[i][n] = x_west + (float(i)-0.5)*self.delta_x_init
        self.y[i][n] = y_nord 
#        print("Nordrand",i,n,  self.x[i][n], self.y[i][n])


# Innere Punkte ??????????????????? liegen wir hier richtig?
      for i in range(1,m):
        for j in range(1,n):
          self.x[i][j] = x_west + (float(i)-0.5)*self.delta_x_init 
          self.y[i][j] = y_süd + (float(j)-0.5)*self.delta_y_init
#          print("Innere Punkte",i,j,  self.x[i][j], self.y[i][j])

#delta_x und delta_y stimmen nicht

      for i in range(m):
        for j in range(n+1):
          self.delta_x[i][j] = self.x[i+1][j] - self.x[i][j]
          print("self.delta_x[i][j]=", i,j,self.delta_x[i][j])
      for i in range(m+1):
        for j in range(n):
          self.delta_y[i][j] = self.y[i][j+1] - self.y[i][j]      
          print("self.delta_x[i][j]=",i,j, self.delta_y[i][j]) 
             
      m += 1
      n += 1 
      return True      
    except:
      print("Fehler bei der Berechnung des FVM-Gitters")   
      return False
