#*************************************************************
# Progamm:			giiter_2d
# Sinn des Programms: 		Gittergenerator
# Sinn der Einheit  :		Einlesen der Steuerdaten aus der Steuerdatei	
# Name dieser Datei:		steuer.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_gitter_2d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	2
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			01.12.2017
# Letzte Änderung: 		16.02.2023
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os


class Steuer:
  #Konstruktormethode
  def __init__(self):		
    print("Steuerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Steuerobjekt entfernt")  

#*************************************************************
# Abschalten der GUI-Funktionen nach Gebrauch
#*************************************************************     
  def ändern(self):
    self.eingabe_gui.destroy()   
    print(self.eingabe_neu())
        
  def ende(self):
    self.eingabe_gui.destroy()     
    
  def ende_neu(self):
    self.eingabe_gui_neu.destroy()  

#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def steuer_input(self):
    self.rückgabeliste = list(range(7))
    self.rückgabeliste[0] = False  					# Steuerdatei vorhanden? True/False  
    self.rückgabeliste[1] = "Steuerdatei ist nicht vorhanden!"
    self.rückgabeliste[2] = True                                   # Einlesen von Steuerdatei korrekt            True/False
    self.rückgabeliste[3] = "Steuerdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen aus Steuerdatei  Text
    self.rückgabeliste[4] = False                                  # Manuelle Änderung                           True/False
    self.rückgabeliste[5] = True                                   # Manuelle Änderung korrekt                   True/False
    self.rückgabeliste[6] = "Keine Fehler in der Änderung"         # Fehlermeldung für manuelle Änderung         Text        Text  
#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists("steuer.txt"): 
      print("Steuerdatei ist vorhanden")
      self.rückgabeliste[0] = True 
      self.rückgabeliste[1] = "Steuerdatei ist vorhanden!"

#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************    
      import tkinter
      self.eingabe_gui = tkinter.Tk()  
      print("Eingabedaten werden eingelesen")
      self.zeilen_zähler = 0
      fobj_in = open("steuer.txt","r")       
      for line in fobj_in:
        self.zeilen_zähler+=1
      fobj_in.close()  
      
      self.anzeige_liste = list(range(self.zeilen_zähler)) 
      self.zeilen_zähler = 0
#*************************************************************
# Öffnen der Steuerdatei
#*************************************************************
      fobj_in = open("steuer.txt","r") 
#*************************************************************
# Einlesen der Steuerdaten zeilenweise
#*************************************************************
      
      for zeile in fobj_in:
        self.anzeige_liste[self.zeilen_zähler] = zeile[:-1]
        if self.zeilen_zähler == 1:
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
          self.gitter_datei = zeile[:-1]
          
        if self.zeilen_zähler == 3:
          self.graphik_datei_name = zeile[:-1]

        if self.zeilen_zähler == 5:
          self.graphik_datei_format = zeile[:-1] 
          self.graphik_formate_zulässig = set(['eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'])
          if self.graphik_datei_format in self.graphik_formate_zulässig:
            pass
          else:
            self.rückgabeliste[2] = False 
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Python unterstützt das Graphikformat nicht!\nProgramm bricht ab!"
                
        if self.zeilen_zähler == 7:
          try:
            self.x_west = float(zeile[:-1])
          except: 
            self.rückgabeliste[2] = False 
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen x_west ist keine Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 9:
          try:
            self.x_ost = float(zeile[:-1])   
            if self.x_west < self.x_ost:
              pass
            else:
              self.rückgabeliste[2] = False  
              self.rückgabeliste[3] = "Fehler in Steuerdatei: x_west muß kleiner x_ost sein!\nProgramm bricht ab!"
          except:
            self.rückgabeliste[2] = False  
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen x_ost ist keine Zahl!\nProgramm bricht ab!"
            
            
        if self.zeilen_zähler == 11:
          try:
            self.y_süd = float(zeile[:-1])
          except: 
            self.rückgabeliste[2] = False 
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen y_süd ist keine Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 13:
          try:
            self.y_nord = float(zeile[:-1])   
            if self.y_süd < self.y_nord:
              pass
            else:
              self.rückgabeliste[2] = False  
              self.rückgabeliste[3] = "Fehler in Steuerdatei: y_süd muß kleiner y_nord sein!\nProgramm bricht ab!"
          except:
            self.rückgabeliste[2] = False  
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen y_süd ist keine Zahl!\nProgramm bricht ab!"            
                               
        if self.zeilen_zähler == 15:
          try:
            self.m = int(zeile[:-1])
            if self.m > 4:
              pass
            else:
              self.rückgabeliste[2] = False  
              self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen m ist zu klein!\nm sollte > 4 sein.\nProgramm bricht ab!"
              print(self.rückgabeliste[3])   
          except:
            self.rückgabeliste[2] = False  
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen m ist keine Integer-Zahl!\nProgramm bricht ab!"
            
        if self.zeilen_zähler == 17:
          try:
            self.n = int(zeile[:-1])
            if self.n > 4:
              pass
            else:
              self.rückgabeliste[2] = False  
              self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen n ist zu klein!\nn sollte > 4 sein.\nProgramm bricht ab!"
              print(self.rückgabeliste[1])   
          except:
            self.rückgabeliste[2] = False  
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen m ist keine Integer-Zahl!\nProgramm bricht ab!"            
                   
        if self.zeilen_zähler == 19: 
          self.gitter_typ = zeile[:-1]
          if self.gitter_typ == "v" or self.gitter_typ == "d":
            pass
          else:
            self.rückgabeliste[2] = False  
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen gitter_typ muß d oder v sein!\nProgramm bricht ab!"  

        if self.zeilen_zähler == 21:
          try:
            self.t_init = float(zeile[:-1])
            if self.t_init > 0.0:
              pass
            else:
              self.rückgabeliste[2] = False 
              self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen t_init muß größer 0 sein!\nProgramm bricht ab!"  
          except: 
            self.rückgabeliste[2] = False 
            self.rückgabeliste[3] = "Fehler in Steuerdatei: Wert der Variablen A_init ist keine Zahl!\nProgramm bricht ab!"
              
        if self.zeilen_zähler == 23:
          self.index_ausgabe_wähler = self.bool_function(zeile[:-1]) 
        if self.zeilen_zähler == 25:
          self.ascii_bin = zeile[:-1]
        if self.zeilen_zähler == 27:
          self.schirm_ausgabe_wähler = self.bool_function(zeile[:-1]) 
        if self.zeilen_zähler == 29:
          self.datei_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 31:
          self.graphik_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 33:
          self.graphik_datei_ausgabe_wähler = self.bool_function(zeile[:-1])              
        self.zeilen_zähler += 1    
      fobj_in.close()

#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
#*************************************************************   
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui, text = self.anzeige_liste[i])
        
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
          #lb["font"] = "Arial 6 bold"
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten und 
# zum Start der Berechnungen
#*************************************************************
      weiter_button = tkinter.Button(self.eingabe_gui, text = "weiter", command = self.ende)
      weiter_button.grid(row=int(i/2+1), column=0, padx='1', pady='1', sticky='ew')
      ändern_button = tkinter.Button(self.eingabe_gui, text = "Eingabe ändern", command = self.ändern)
      ändern_button.grid(row=int(i/2+1), column=1, padx='1', pady='1', sticky='ew')
      #Endlosschleife
      self.eingabe_gui.mainloop()
      print("Einlesen der Steuerdaten o.k.")

    else:
      self.rückgabeliste[0] = False  					# Steuerdatei vorhanden? True/False  
      self.rückgabeliste[1] = "Steuerdatei ist nicht vorhanden!" 
      self.rückgabeliste[2] = False  
    return self.rückgabeliste[2] 
  def übernahme(self): 
    dummy = self.änderungs_feld_gitter_datei.get()
#*************************************************************
# Test ob in das Feld etwas eingeschrieben wurde
# wenn nicht, dann dummy != "" False
#*************************************************************    
    if dummy != "" and dummy != self.gitter_datei:  
      self.rückgabeliste[4] = True         
      self.gitter_datei = dummy
      print("gitter_datei geändert:", self.gitter_datei) 
    else:
      print("Keine Änderung der Variablen")
            
    dummy = self.änderungs_feld_graphik_datei_name.get()
    if dummy != "" and dummy != self.graphik_datei_name:   
      self.rückgabeliste[4] = True 
      self.graphik_datei_name = dummy
      print("graphik_datei_name geändert:", self.graphik_datei_name) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_graphik_datei_format.get()
    if dummy != "" and dummy != self.graphik_datei_format:  
      self.rückgabeliste[4] = True  
      if dummy in self.graphik_formate_zulässig:
        self.graphik_datei_format = dummy
      else:
        self.rückgabeliste[5] = False 
        self.rückgabeliste[6] = "Fehler in Eingabe: Python unterstützt das Graphikformat nicht!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      print("graphik_datei_format geändert:",  self.graphik_datei_format) 
    else:
      print("Keine Änderung der Variablen") 


#*************************************************************
# Test ob in das Feld eingeschriebene(s) Zeichen eine Zahl ist/sind
# d.h. zu float konvertierbar ist
#*************************************************************

    dummy = self.änderungs_feld_x_west.get()
    if dummy != "" and dummy != self.x_west:  
      try:
        if float(dummy) < self.x_ost:
          self.x_west = float(dummy)
          self.rückgabeliste[4] = True 
          print("x_ost geändert:",  self.x_west) 
        else:
          self.rückgabeliste[5] = False  
          self.rückgabeliste[6] = "Fehler in Steuerdatei: x_west muß kleiner x_ost sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[5] = False
        self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen x_ost ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")         
      
    dummy = self.änderungs_feld_x_ost.get()
    if dummy != "" and dummy != self.x_ost:   
      try:
        if self.x_west < float(dummy):
          self.x_ost = float(dummy)
          self.rückgabeliste[4] = True 
          print("x_ost geändert:",  self.x_ost) 
        else:
          self.rückgabeliste[5] = False  
          self.rückgabeliste[6] = "Fehler in Steuerdatei: x_west muß kleiner x_ost sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[5] = False
        self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen x_ost ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")  
 
    dummy = self.änderungs_feld_y_süd.get()
    if dummy != "" and dummy != self.y_süd:   
      try:
        if float(dummy) < self.y_nord:
          self.y_süd = float(dummy)
          self.rückgabeliste[4] = True 
          print("y_süd geändert:",  self.y_süd) 
        else:
          self.rückgabeliste[5] = False  
          self.rückgabeliste[6] = "Fehler in Steuerdatei: y_süd muß kleiner y_nord sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[5] = False
        self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen y_süd ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")         
      
    dummy = self.änderungs_feld_y_nord.get()
    if dummy != "" and dummy != self.y_nord:  
      try:
        if self.y_süd < float(dummy):
          self.y_nord = float(dummy)
          self.rückgabeliste[4] = True 
          print("y_nord geändert:",  self.y_nord) 
        else:
          self.rückgabeliste[5] = False  
          self.rückgabeliste[6] = "Fehler in Steuerdatei: y_süd muß kleiner y_nord sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[5] = False
        self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen y-nord ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")  
 
  
      
    dummy = self.änderungs_feld_m.get()
    if dummy != "" and dummy != self.m:  
      self.rückgabeliste[4] = True 
      try:
        test_integer = int(dummy) 
        if test_integer > 4:
          self.m = int(dummy)
          print("m geändert:",  self.m)
        else:
          self.rückgabeliste[5] = False
          self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen m ist zu klein!\nm sollte > 4 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[5] = False
        self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen m ist keine Integer-Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")     
                
    dummy = self.änderungs_feld_n.get()
    if dummy != ""  and dummy != self.n:  
      self.rückgabeliste[4] = True 
      try:
        test_integer = int(dummy) 
        if test_integer > 4:
          self.n = int(dummy)
          print("n geändert:",  self.n)
        else:
          self.rückgabeliste[5] = False
          self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen n ist zu klein!\nn sollte > 4 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[5] = False
        self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen n ist keine Integer-Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")     
      
                      
    dummy = self.änderungs_feld_gitter_typ.get()
    if dummy != "" and dummy != self.gitter_typ:
      if dummy == "v" or dummy == "d":
        self.rückgabeliste[4] = True 
        self.gitter_typ = dummy 
        print("gitter_typ geändert:",  self.gitter_typ)
      else:
        self.rückgabeliste[5] = False  
        self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen gitter_typ muß d oder v sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"   
    else:
      print("Keine Änderung der Variablen")  
      

    dummy = self.änderungs_feld_t_init.get()
    if dummy != "" and dummy != self.t_init:
      self.rückgabeliste[4] = True   
      try:
        if float(dummy) > 0.0:
          self.t_init = float(dummy)
          print("t_init geändert:",  self.t_init) 
        else:
          self.rückgabeliste[5] = False
          self.rückgabeliste[6] = "Fehler in Eingabe: Wert der Variablen t_init muß > 0 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        print("Zahl in das Feld eingeben!")
    else:
      print("Keine Änderung der Variablen")       
      
    dummy = self.änderungs_feld_index.get()
    if dummy != "" and dummy != str(self.index_ausgabe_wähler):  
      self.rückgabeliste[4] = True 
      self.index_ausgabe_wähler =  self.bool_function(dummy)
      print("index geändert:",  self.index_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_ascii_bin.get()
    if dummy != "" and dummy != self.ascii_bin: 
      self.rückgabeliste[4] = True 
      self.ascii_bin = dummy
      print("ascii_bin_neu geändert:",  self.ascii_bin) 
    else:
      print("Keine Änderung der Variablen")      
      
    dummy = self.änderungs_feld_schirm_ausgabe_wähler.get()
    if dummy != "" and dummy !=  str(self.schirm_ausgabe_wähler):  
      self.rückgabeliste[4] = True 
      self.schirm_ausgabe_wähler = self.bool_function(dummy)
      print("schirm_ausgabe_wähler geändert:",  self.schirm_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_datei_ausgabe_wähler.get()
    if dummy != "" and dummy !=  str(self.datei_ausgabe_wähler):   
      self.rückgabeliste[4] = True 
      self.datei_ausgabe_wähler =self.bool_function(dummy)
      print("datei_ausgabe_wähler geändert:", self.datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen")                          
                                    
    dummy = self.änderungs_feld_graphik_ausgabe_wähler.get()
    if dummy != "" and dummy !=  str(self.graphik_ausgabe_wähler):  
      self.rückgabeliste[4] = True 
      self.graphik_ausgabe_wähler = self.bool_function(dummy)
      print("graphik_ausgabe_wähler geändert:", self.graphik_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen") 
      
    dummy = self.änderungs_feld_graphik_datei_ausgabe_wähler.get()
    if dummy != "" and dummy !=  str(self.graphik_datei_ausgabe_wähler):  
      self.rückgabeliste[4] = True 
      self.graphik_datei_ausgabe_wähler = self.bool_function(dummy)
      print("graphik_datei_ausgabe_wähler geändert:", self.graphik_datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen") 


#*************************************************************
# Abspeichern der veränderten Eingabedaten in eine neue Datei
#*************************************************************
    if(self.rückgabeliste[4] == True ):
      fobj_out = open("steuer_neu.txt","w")   
      fobj_out.write("Name der Gitterdatei:\n")
      fobj_out.write(self.gitter_datei)
      fobj_out.write("\n")
      fobj_out.write("Name der Graphikdatei:\n")
      fobj_out.write(self.graphik_datei_name) 
      fobj_out.write("\n")
      fobj_out.write("Format der Graphikdatei:\n")
      fobj_out.write(self.graphik_datei_format)
      fobj_out.write("\n")
      fobj_out.write("x_west:\n")
      fobj_out.write(str("%8.6f" %self.x_west))
      fobj_out.write("\n")
      fobj_out.write("x_ost:\n")
      fobj_out.write(str("%8.6f" %self.x_ost))
      fobj_out.write("\n")
      fobj_out.write("y_süd:\n")
      fobj_out.write(str("%8.6f" %self.y_süd))
      fobj_out.write("\n")
      fobj_out.write("y_nord:\n")
      fobj_out.write(str("%8.6f" %self.y_nord))
      fobj_out.write("\n")      
      fobj_out.write("Anzahl der Gitterpunkte in x-Richtung:\n")
      fobj_out.write(str("%8i" %self.m))
      fobj_out.write("\n")
      fobj_out.write("Anzahl der Gitterpunkte in y-Richtung:\n")
      fobj_out.write(str("%8i" %self.n))
      fobj_out.write("\n")      
      fobj_out.write("FDM- oder FVM- Gitter:\n")
      fobj_out.write(self.gitter_typ)
      fobj_out.write("\n")
      fobj_out.write("Tiefe eines Kontrollvolumens:\n")
      fobj_out.write(str("%18.16f" %self.t_init))
      fobj_out.write("\n")
      fobj_out.write("Ausgabe mit Indizes\n")
      fobj_out.write(str(self.index_ausgabe_wähler))
      fobj_out.write("\n")
      fobj_out.write("Ausgabe ASCII oder binär:\n")
      fobj_out.write(self.ascii_bin)
      fobj_out.write("\n")
      fobj_out.write("Bildschirmausgabe?:\n")
      fobj_out.write(str(self.schirm_ausgabe_wähler)) 
      fobj_out.write("\n")     
      fobj_out.write("Dateiausgabe?:\n")
      fobj_out.write(str(self.datei_ausgabe_wähler)) 
      fobj_out.write("\n")
      fobj_out.write("Graphikausgabe?:\n")
      fobj_out.write(str(self.graphik_ausgabe_wähler)) 
      fobj_out.write("Graphikdateiausgabe?:\n")
      fobj_out.write(str(self.graphik_datei_ausgabe_wähler)) 
      fobj_out.write("\n")                      
      fobj_out.close   
    else:
      pass
                                
#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
# sowie der Möglichkeit, andere Eingabedaten einzugeben
#*************************************************************    
  def eingabe_neu(self):
    try:
      import tkinter
      self.eingabe_gui_neu = tkinter.Tk() 
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui_neu, text = self.anzeige_liste[i])
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
 
 
# Radio-Button-Variablen
      self.gitter_typ_zwischen = tkinter.StringVar()
      self.gitter_typ_zwischen.set(self.gitter_typ) 
      self.index_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.index_ausgabe_wähler_zwischen.set(str(self.index_ausgabe_wähler))  
      self.ascii_bin_zwischen = tkinter.StringVar()
      self.ascii_bin_zwischen.set(self.ascii_bin) 
      self.schirm_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.schirm_ausgabe_wähler_zwischen.set(str(self.schirm_ausgabe_wähler))     
      self.datei_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.datei_ausgabe_wähler_zwischen.set(str(self.datei_ausgabe_wähler))   
      self.graphik_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.graphik_ausgabe_wähler_zwischen.set(str(self.graphik_ausgabe_wähler))  
      self.graphik_datei_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.graphik_datei_ausgabe_wähler_zwischen.set(str(self.graphik_datei_ausgabe_wähler))    
 
      
      self.änderungs_feld_gitter_datei = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_datei_name = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_datei_format = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_x_west= tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_x_ost = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_y_süd= tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_y_nord = tkinter.Entry(self.eingabe_gui_neu)      
      self.änderungs_feld_m = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_n = tkinter.Entry(self.eingabe_gui_neu)      
# Radio_button     
      self.änderungs_feld_gitter_typ_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="FDM",variable=self.gitter_typ_zwischen, value = "d")
      self.änderungs_feld_gitter_typ_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="FVM",variable=self.gitter_typ_zwischen, value = "v")  
      self.änderungs_feld_t_init = tkinter.Entry(self.eingabe_gui_neu)
# Radio_button   
      self.änderungs_feld_index_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.index_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_index_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.index_ausgabe_wähler_zwischen, value = "False")
# Radio_button     
      self.änderungs_feld_ascii_bin_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="ASCII",variable=self.ascii_bin_zwischen, value = "a")
      self.änderungs_feld_ascii_bin_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="binär",variable=self.ascii_bin_zwischen, value = "b")   
# Radio_button     
      self.änderungs_feld_schirm_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.schirm_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_schirm_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.schirm_ausgabe_wähler_zwischen, value = "False")  
# Radio_button     
      self.änderungs_feld_datei_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.datei_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_datei_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.datei_ausgabe_wähler_zwischen, value = "False")
# Radio_button 
      self.änderungs_feld_graphik_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.graphik_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_graphik_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.graphik_ausgabe_wähler_zwischen, value = "False") 
# Radio_button 
      self.änderungs_feld_graphik_datei_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.graphik_datei_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_graphik_datei_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.graphik_datei_ausgabe_wähler_zwischen, value = "False") 
      self.änderungs_feld_gitter_datei.grid(row=0, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')    
      self.änderungs_feld_graphik_datei_name.grid(row=1, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')      
      self.änderungs_feld_graphik_datei_format.grid(row=2, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_x_west.grid(row=3, column=2, padx='1', columnspan = 2, pady='1', sticky='ew')  
      self.änderungs_feld_x_ost.grid(row=4, column=2, padx='1', columnspan = 2, pady='1', sticky='ew')
      self.änderungs_feld_y_süd.grid(row=5, column=2, padx='1', columnspan = 2, pady='1', sticky='ew')  
      self.änderungs_feld_y_nord.grid(row=6, column=2, padx='1', columnspan = 2, pady='1', sticky='ew')      
      self.änderungs_feld_m .grid(row=7, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_n .grid(row=8, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')       
# Radio_button          
      self.änderungs_feld_gitter_typ_1.grid(row=9, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_gitter_typ_2.grid(row=9, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_gitter_typ = self.gitter_typ_zwischen 
      self.änderungs_feld_t_init.grid(row=10, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
# Radio_button
      self.änderungs_feld_index_ausgabe_wähler_1.grid(row=11, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_index_ausgabe_wähler_2.grid(row=11, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_index = self.index_ausgabe_wähler_zwischen 
# Radio_button          
      self.änderungs_feld_ascii_bin_1.grid(row=12, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_ascii_bin_2.grid(row=12, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_ascii_bin = self.ascii_bin_zwischen 
# Radio_button
      self.änderungs_feld_schirm_ausgabe_wähler_1.grid(row=13, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_schirm_ausgabe_wähler_2.grid(row=13, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_schirm_ausgabe_wähler = self.schirm_ausgabe_wähler_zwischen  
# Radio_button
      self.änderungs_feld_datei_ausgabe_wähler_1.grid(row=14, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_datei_ausgabe_wähler_2.grid(row=14, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_datei_ausgabe_wähler = self.datei_ausgabe_wähler_zwischen    
# Radio_button
      self.änderungs_feld_graphik_ausgabe_wähler_1.grid(row=15, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_ausgabe_wähler_2.grid(row=15, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_ausgabe_wähler = self.graphik_ausgabe_wähler_zwischen 
# Radio_button
      self.änderungs_feld_graphik_datei_ausgabe_wähler_1.grid(row=16, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_datei_ausgabe_wähler_2.grid(row=16, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_datei_ausgabe_wähler = self.graphik_datei_ausgabe_wähler_zwischen  
 
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten
# Button zur Übernahme der geänderten Eingabedaten
# zum Start der Berechnungen
#*************************************************************      
      weiter_button = tkinter.Button(self.eingabe_gui_neu, text = "weiter", command = self.ende_neu)
      weiter_button.grid(row=17, column=0, padx='1', pady='1', sticky='ew')
      übernahme_button = tkinter.Button(self.eingabe_gui_neu, text = "übernehmen", command = self.übernahme)
      übernahme_button.grid(row=17, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      
      #Endlosschleife
      self.eingabe_gui_neu.mainloop()
           
      print("Einlesen o.k.")
      self.rückgabewert = True
  
    except:
      print("Fehler beim Dateieinlesen")
      self.rückgabewert = False
    return self.rückgabewert   

     
  def bool_function(self,arg):
    s_true = set(["True", "true", "T", "t", "1" ])
    s_false = set(["False", "false", "F", "f", "0" ])
    if arg in s_true:
      return True
    elif arg in s_false:
      return False
    else:     
      return True

